#include <stdio.h>
#include <stdlib.h>

#include <string.h>
#include <strings.h>

#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>

#include <unistd.h>
#include <fcntl.h>

#include <netdb.h>


#ifdef __CYGWIN__
typedef unsigned int socklen_t;
#endif

void usage(int argc, char* argv[])
{
  printf("Usage: %s <host> <port>\n", argv[0]);
  printf("Example: %s localhost 10025\n", argv[0]);
}

int MakeUdpSocket(char *hostname, char *port, struct sockaddr_in *to)
{
	 struct hostent *hp;					
	 int portnum;							
	 int sock;						
	 hp = gethostbyname(hostname);					
	 if (hp == NULL)						
		{
		  perror("No host to connect to");		
		  exit(1);				
		}

	 bcopy((char *)hp->h_addr, (char *)&to->sin_addr, hp->h_length); 
	 to->sin_family = AF_INET;					
	 sscanf(port, "%d", &portnum);					
	 to->sin_port = htons(portnum);				
	 sock = socket(AF_INET, SOCK_DGRAM, 0);			
	 if (sock < 0)							
		{
		 perror("Unable to create socket");		
		 exit(1);					
		}

	 return sock;						
}


int main(int argc, char *argv[], char* env[])
{

  int ret;
  char buf[1024];
  struct sockaddr_in to;
  int sock;

  if (argc < 3) {
	usage(argc, argv);
	exit(0);
  }

  sock = socket(AF_INET, SOCK_DGRAM, 0);
  if (sock < 0)
  {
     perror ("couldn't create socket");
     exit (1);
  }

  MakeUdpSocket(argv[1], argv[2], &to);

  strncpy(buf, "Hoi\0", strlen("Hoi\0"));
  ret = sendto(sock, buf, strlen(buf), 0, (struct sockaddr *)&to, sizeof(to));

  return 0;
}
